# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = [
    'GetDomainsDomainResult',
    'GetMailAddressesAddressResult',
    'GetReceiversReceiverseResult',
    'GetTagsTagResult',
]

@pulumi.output_type
class GetDomainsDomainResult(dict):
    def __init__(__self__, *,
                 cname_auth_status: builtins.str,
                 cname_confirm_status: builtins.str,
                 cname_record: builtins.str,
                 create_time: builtins.str,
                 default_domain: builtins.str,
                 dkim_auth_status: builtins.str,
                 dkim_public_key: builtins.str,
                 dkim_rr: builtins.str,
                 dmarc_auth_status: builtins.str,
                 dmarc_host_record: builtins.str,
                 dmarc_record: builtins.str,
                 dns_dmarc: builtins.str,
                 dns_mx: builtins.str,
                 dns_spf: builtins.str,
                 dns_txt: builtins.str,
                 domain_id: builtins.str,
                 domain_name: builtins.str,
                 domain_record: builtins.str,
                 domain_type: builtins.str,
                 host_record: builtins.str,
                 icp_status: builtins.str,
                 id: builtins.str,
                 mx_auth_status: builtins.str,
                 mx_record: builtins.str,
                 spf_auth_status: builtins.str,
                 spf_record: builtins.str,
                 status: builtins.str,
                 tl_domain_name: builtins.str,
                 tracef_record: builtins.str):
        """
        :param builtins.str cname_auth_status: Indicates whether your ownership of the domain is verified.
        :param builtins.str cname_confirm_status: Indicates whether the CNAME record is successfully verified. **Note:** `cname_confirm_status` takes effect only if `enable_details` is set to `true`.
        :param builtins.str cname_record: The value of the CNAME record. **Note:** `cname_record` takes effect only if `enable_details` is set to `true`.
        :param builtins.str create_time: The time when the DNS record was created.
        :param builtins.str default_domain: The default domain name. **Note:** `default_domain` takes effect only if `enable_details` is set to `true`.
        :param builtins.str dkim_auth_status: (Available since v1.227.1) The DKIM validation flag. **Note:** `dkim_auth_status` takes effect only if `enable_details` is set to `true`.
        :param builtins.str dkim_public_key: (Available since v1.227.1) The DKIM public key. **Note:** `dkim_public_key` takes effect only if `enable_details` is set to `true`.
        :param builtins.str dkim_rr: (Available since v1.227.1) The DKIM Host Record. **Note:** `dkim_rr` takes effect only if `enable_details` is set to `true`.
        :param builtins.str dmarc_auth_status: (Available since v1.227.1) The DMARC validation flag. **Note:** `dmarc_auth_status` takes effect only if `enable_details` is set to `true`.
        :param builtins.str dmarc_host_record: (Available since v1.227.1) The DMARC Host Record. **Note:** `dmarc_host_record` takes effect only if `enable_details` is set to `true`.
        :param builtins.str dmarc_record: (Available since v1.227.1) The DMARC record. **Note:** `dmarc_record` takes effect only if `enable_details` is set to `true`.
        :param builtins.str dns_dmarc: (Available since v1.227.1) The DMARC record value resolved through public DNS. **Note:** `dns_dmarc` takes effect only if `enable_details` is set to `true`.
        :param builtins.str dns_mx: The MX record value resolved through public DNS. **Note:** `dns_mx` takes effect only if `enable_details` is set to `true`.
        :param builtins.str dns_spf: The SPF record value resolved through public DNS. **Note:** `dns_spf` takes effect only if `enable_details` is set to `true`.
        :param builtins.str dns_txt: The TXT record value resolved through public DNS. **Note:** `dns_txt` takes effect only if `enable_details` is set to `true`.
        :param builtins.str domain_id: The ID of the domain name.
        :param builtins.str domain_name: The domain name.
        :param builtins.str domain_record: (Available since v1.227.1) The value of the Domain record.
        :param builtins.str domain_type: The type of the domain. **Note:** `domain_type` takes effect only if `enable_details` is set to `true`.
        :param builtins.str host_record: (Available since v1.227.1) The value of the host record. **Note:** `host_record` takes effect only if `enable_details` is set to `true`.
        :param builtins.str icp_status: The status of ICP filing.
        :param builtins.str id: The ID of the Domain.
        :param builtins.str mx_auth_status: Indicates whether the MX record is successfully verified.
        :param builtins.str mx_record: The MX verification record provided by the Direct Mail console. **Note:** `mx_record` takes effect only if `enable_details` is set to `true`.
        :param builtins.str spf_auth_status: Indicates whether the SPF record is successfully verified.
        :param builtins.str spf_record: The SPF verification record provided by the Direct Mail console. **Note:** `spf_record` takes effect only if `enable_details` is set to `true`.
        :param builtins.str status: The status of the domain name. Valid values:
        :param builtins.str tl_domain_name: The primary domain name. **Note:** `tl_domain_name` takes effect only if `enable_details` is set to `true`.
        :param builtins.str tracef_record: The CNAME verification record provided by the Direct Mail console. **Note:** `tracef_record` takes effect only if `enable_details` is set to `true`.
        """
        pulumi.set(__self__, "cname_auth_status", cname_auth_status)
        pulumi.set(__self__, "cname_confirm_status", cname_confirm_status)
        pulumi.set(__self__, "cname_record", cname_record)
        pulumi.set(__self__, "create_time", create_time)
        pulumi.set(__self__, "default_domain", default_domain)
        pulumi.set(__self__, "dkim_auth_status", dkim_auth_status)
        pulumi.set(__self__, "dkim_public_key", dkim_public_key)
        pulumi.set(__self__, "dkim_rr", dkim_rr)
        pulumi.set(__self__, "dmarc_auth_status", dmarc_auth_status)
        pulumi.set(__self__, "dmarc_host_record", dmarc_host_record)
        pulumi.set(__self__, "dmarc_record", dmarc_record)
        pulumi.set(__self__, "dns_dmarc", dns_dmarc)
        pulumi.set(__self__, "dns_mx", dns_mx)
        pulumi.set(__self__, "dns_spf", dns_spf)
        pulumi.set(__self__, "dns_txt", dns_txt)
        pulumi.set(__self__, "domain_id", domain_id)
        pulumi.set(__self__, "domain_name", domain_name)
        pulumi.set(__self__, "domain_record", domain_record)
        pulumi.set(__self__, "domain_type", domain_type)
        pulumi.set(__self__, "host_record", host_record)
        pulumi.set(__self__, "icp_status", icp_status)
        pulumi.set(__self__, "id", id)
        pulumi.set(__self__, "mx_auth_status", mx_auth_status)
        pulumi.set(__self__, "mx_record", mx_record)
        pulumi.set(__self__, "spf_auth_status", spf_auth_status)
        pulumi.set(__self__, "spf_record", spf_record)
        pulumi.set(__self__, "status", status)
        pulumi.set(__self__, "tl_domain_name", tl_domain_name)
        pulumi.set(__self__, "tracef_record", tracef_record)

    @property
    @pulumi.getter(name="cnameAuthStatus")
    def cname_auth_status(self) -> builtins.str:
        """
        Indicates whether your ownership of the domain is verified.
        """
        return pulumi.get(self, "cname_auth_status")

    @property
    @pulumi.getter(name="cnameConfirmStatus")
    def cname_confirm_status(self) -> builtins.str:
        """
        Indicates whether the CNAME record is successfully verified. **Note:** `cname_confirm_status` takes effect only if `enable_details` is set to `true`.
        """
        return pulumi.get(self, "cname_confirm_status")

    @property
    @pulumi.getter(name="cnameRecord")
    def cname_record(self) -> builtins.str:
        """
        The value of the CNAME record. **Note:** `cname_record` takes effect only if `enable_details` is set to `true`.
        """
        return pulumi.get(self, "cname_record")

    @property
    @pulumi.getter(name="createTime")
    def create_time(self) -> builtins.str:
        """
        The time when the DNS record was created.
        """
        return pulumi.get(self, "create_time")

    @property
    @pulumi.getter(name="defaultDomain")
    def default_domain(self) -> builtins.str:
        """
        The default domain name. **Note:** `default_domain` takes effect only if `enable_details` is set to `true`.
        """
        return pulumi.get(self, "default_domain")

    @property
    @pulumi.getter(name="dkimAuthStatus")
    def dkim_auth_status(self) -> builtins.str:
        """
        (Available since v1.227.1) The DKIM validation flag. **Note:** `dkim_auth_status` takes effect only if `enable_details` is set to `true`.
        """
        return pulumi.get(self, "dkim_auth_status")

    @property
    @pulumi.getter(name="dkimPublicKey")
    def dkim_public_key(self) -> builtins.str:
        """
        (Available since v1.227.1) The DKIM public key. **Note:** `dkim_public_key` takes effect only if `enable_details` is set to `true`.
        """
        return pulumi.get(self, "dkim_public_key")

    @property
    @pulumi.getter(name="dkimRr")
    def dkim_rr(self) -> builtins.str:
        """
        (Available since v1.227.1) The DKIM Host Record. **Note:** `dkim_rr` takes effect only if `enable_details` is set to `true`.
        """
        return pulumi.get(self, "dkim_rr")

    @property
    @pulumi.getter(name="dmarcAuthStatus")
    def dmarc_auth_status(self) -> builtins.str:
        """
        (Available since v1.227.1) The DMARC validation flag. **Note:** `dmarc_auth_status` takes effect only if `enable_details` is set to `true`.
        """
        return pulumi.get(self, "dmarc_auth_status")

    @property
    @pulumi.getter(name="dmarcHostRecord")
    def dmarc_host_record(self) -> builtins.str:
        """
        (Available since v1.227.1) The DMARC Host Record. **Note:** `dmarc_host_record` takes effect only if `enable_details` is set to `true`.
        """
        return pulumi.get(self, "dmarc_host_record")

    @property
    @pulumi.getter(name="dmarcRecord")
    def dmarc_record(self) -> builtins.str:
        """
        (Available since v1.227.1) The DMARC record. **Note:** `dmarc_record` takes effect only if `enable_details` is set to `true`.
        """
        return pulumi.get(self, "dmarc_record")

    @property
    @pulumi.getter(name="dnsDmarc")
    def dns_dmarc(self) -> builtins.str:
        """
        (Available since v1.227.1) The DMARC record value resolved through public DNS. **Note:** `dns_dmarc` takes effect only if `enable_details` is set to `true`.
        """
        return pulumi.get(self, "dns_dmarc")

    @property
    @pulumi.getter(name="dnsMx")
    def dns_mx(self) -> builtins.str:
        """
        The MX record value resolved through public DNS. **Note:** `dns_mx` takes effect only if `enable_details` is set to `true`.
        """
        return pulumi.get(self, "dns_mx")

    @property
    @pulumi.getter(name="dnsSpf")
    def dns_spf(self) -> builtins.str:
        """
        The SPF record value resolved through public DNS. **Note:** `dns_spf` takes effect only if `enable_details` is set to `true`.
        """
        return pulumi.get(self, "dns_spf")

    @property
    @pulumi.getter(name="dnsTxt")
    def dns_txt(self) -> builtins.str:
        """
        The TXT record value resolved through public DNS. **Note:** `dns_txt` takes effect only if `enable_details` is set to `true`.
        """
        return pulumi.get(self, "dns_txt")

    @property
    @pulumi.getter(name="domainId")
    def domain_id(self) -> builtins.str:
        """
        The ID of the domain name.
        """
        return pulumi.get(self, "domain_id")

    @property
    @pulumi.getter(name="domainName")
    def domain_name(self) -> builtins.str:
        """
        The domain name.
        """
        return pulumi.get(self, "domain_name")

    @property
    @pulumi.getter(name="domainRecord")
    def domain_record(self) -> builtins.str:
        """
        (Available since v1.227.1) The value of the Domain record.
        """
        return pulumi.get(self, "domain_record")

    @property
    @pulumi.getter(name="domainType")
    def domain_type(self) -> builtins.str:
        """
        The type of the domain. **Note:** `domain_type` takes effect only if `enable_details` is set to `true`.
        """
        return pulumi.get(self, "domain_type")

    @property
    @pulumi.getter(name="hostRecord")
    def host_record(self) -> builtins.str:
        """
        (Available since v1.227.1) The value of the host record. **Note:** `host_record` takes effect only if `enable_details` is set to `true`.
        """
        return pulumi.get(self, "host_record")

    @property
    @pulumi.getter(name="icpStatus")
    def icp_status(self) -> builtins.str:
        """
        The status of ICP filing.
        """
        return pulumi.get(self, "icp_status")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The ID of the Domain.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="mxAuthStatus")
    def mx_auth_status(self) -> builtins.str:
        """
        Indicates whether the MX record is successfully verified.
        """
        return pulumi.get(self, "mx_auth_status")

    @property
    @pulumi.getter(name="mxRecord")
    def mx_record(self) -> builtins.str:
        """
        The MX verification record provided by the Direct Mail console. **Note:** `mx_record` takes effect only if `enable_details` is set to `true`.
        """
        return pulumi.get(self, "mx_record")

    @property
    @pulumi.getter(name="spfAuthStatus")
    def spf_auth_status(self) -> builtins.str:
        """
        Indicates whether the SPF record is successfully verified.
        """
        return pulumi.get(self, "spf_auth_status")

    @property
    @pulumi.getter(name="spfRecord")
    def spf_record(self) -> builtins.str:
        """
        The SPF verification record provided by the Direct Mail console. **Note:** `spf_record` takes effect only if `enable_details` is set to `true`.
        """
        return pulumi.get(self, "spf_record")

    @property
    @pulumi.getter
    def status(self) -> builtins.str:
        """
        The status of the domain name. Valid values:
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter(name="tlDomainName")
    def tl_domain_name(self) -> builtins.str:
        """
        The primary domain name. **Note:** `tl_domain_name` takes effect only if `enable_details` is set to `true`.
        """
        return pulumi.get(self, "tl_domain_name")

    @property
    @pulumi.getter(name="tracefRecord")
    def tracef_record(self) -> builtins.str:
        """
        The CNAME verification record provided by the Direct Mail console. **Note:** `tracef_record` takes effect only if `enable_details` is set to `true`.
        """
        return pulumi.get(self, "tracef_record")


@pulumi.output_type
class GetMailAddressesAddressResult(dict):
    def __init__(__self__, *,
                 account_name: builtins.str,
                 create_time: builtins.str,
                 daily_count: builtins.str,
                 daily_req_count: builtins.str,
                 domain_status: builtins.str,
                 id: builtins.str,
                 mail_address_id: builtins.str,
                 month_count: builtins.str,
                 month_req_count: builtins.str,
                 reply_address: builtins.str,
                 reply_status: builtins.str,
                 sendtype: builtins.str,
                 status: builtins.str):
        """
        :param builtins.str account_name: The sender address.
        :param builtins.str create_time: The creation of the record time.
        :param builtins.str daily_count: On the quota limit.
        :param builtins.str daily_req_count: On the quota.
        :param builtins.str domain_status: Domain name status. Valid values: `0`, `1`.
        :param builtins.str id: The ID of the Mail Address.
        :param builtins.str mail_address_id: The sender address ID.
        :param builtins.str month_count: Monthly quota limit.
        :param builtins.str month_req_count: Months amount.
        :param builtins.str reply_address: Return address.
        :param builtins.str reply_status: If using STMP address status.
        :param builtins.str sendtype: Account type.
        :param builtins.str status: Account Status. Valid values: `0`, `1`. Freeze: 1, normal: 0.
        """
        pulumi.set(__self__, "account_name", account_name)
        pulumi.set(__self__, "create_time", create_time)
        pulumi.set(__self__, "daily_count", daily_count)
        pulumi.set(__self__, "daily_req_count", daily_req_count)
        pulumi.set(__self__, "domain_status", domain_status)
        pulumi.set(__self__, "id", id)
        pulumi.set(__self__, "mail_address_id", mail_address_id)
        pulumi.set(__self__, "month_count", month_count)
        pulumi.set(__self__, "month_req_count", month_req_count)
        pulumi.set(__self__, "reply_address", reply_address)
        pulumi.set(__self__, "reply_status", reply_status)
        pulumi.set(__self__, "sendtype", sendtype)
        pulumi.set(__self__, "status", status)

    @property
    @pulumi.getter(name="accountName")
    def account_name(self) -> builtins.str:
        """
        The sender address.
        """
        return pulumi.get(self, "account_name")

    @property
    @pulumi.getter(name="createTime")
    def create_time(self) -> builtins.str:
        """
        The creation of the record time.
        """
        return pulumi.get(self, "create_time")

    @property
    @pulumi.getter(name="dailyCount")
    def daily_count(self) -> builtins.str:
        """
        On the quota limit.
        """
        return pulumi.get(self, "daily_count")

    @property
    @pulumi.getter(name="dailyReqCount")
    def daily_req_count(self) -> builtins.str:
        """
        On the quota.
        """
        return pulumi.get(self, "daily_req_count")

    @property
    @pulumi.getter(name="domainStatus")
    def domain_status(self) -> builtins.str:
        """
        Domain name status. Valid values: `0`, `1`.
        """
        return pulumi.get(self, "domain_status")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The ID of the Mail Address.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="mailAddressId")
    def mail_address_id(self) -> builtins.str:
        """
        The sender address ID.
        """
        return pulumi.get(self, "mail_address_id")

    @property
    @pulumi.getter(name="monthCount")
    def month_count(self) -> builtins.str:
        """
        Monthly quota limit.
        """
        return pulumi.get(self, "month_count")

    @property
    @pulumi.getter(name="monthReqCount")
    def month_req_count(self) -> builtins.str:
        """
        Months amount.
        """
        return pulumi.get(self, "month_req_count")

    @property
    @pulumi.getter(name="replyAddress")
    def reply_address(self) -> builtins.str:
        """
        Return address.
        """
        return pulumi.get(self, "reply_address")

    @property
    @pulumi.getter(name="replyStatus")
    def reply_status(self) -> builtins.str:
        """
        If using STMP address status.
        """
        return pulumi.get(self, "reply_status")

    @property
    @pulumi.getter
    def sendtype(self) -> builtins.str:
        """
        Account type.
        """
        return pulumi.get(self, "sendtype")

    @property
    @pulumi.getter
    def status(self) -> builtins.str:
        """
        Account Status. Valid values: `0`, `1`. Freeze: 1, normal: 0.
        """
        return pulumi.get(self, "status")


@pulumi.output_type
class GetReceiversReceiverseResult(dict):
    def __init__(__self__, *,
                 create_time: builtins.str,
                 description: builtins.str,
                 id: builtins.str,
                 receivers_alias: builtins.str,
                 receivers_id: builtins.str,
                 receivers_name: builtins.str,
                 status: builtins.int):
        """
        :param builtins.str create_time: The creation time of the resource.
        :param builtins.str description: The description.
        :param builtins.str id: The ID of the Receivers.
        :param builtins.str receivers_alias: The Receivers Alias.
        :param builtins.str receivers_id: The first ID of the resource.
        :param builtins.str receivers_name: The name of the resource.
        :param builtins.int status: The status of the resource.
        """
        pulumi.set(__self__, "create_time", create_time)
        pulumi.set(__self__, "description", description)
        pulumi.set(__self__, "id", id)
        pulumi.set(__self__, "receivers_alias", receivers_alias)
        pulumi.set(__self__, "receivers_id", receivers_id)
        pulumi.set(__self__, "receivers_name", receivers_name)
        pulumi.set(__self__, "status", status)

    @property
    @pulumi.getter(name="createTime")
    def create_time(self) -> builtins.str:
        """
        The creation time of the resource.
        """
        return pulumi.get(self, "create_time")

    @property
    @pulumi.getter
    def description(self) -> builtins.str:
        """
        The description.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The ID of the Receivers.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="receiversAlias")
    def receivers_alias(self) -> builtins.str:
        """
        The Receivers Alias.
        """
        return pulumi.get(self, "receivers_alias")

    @property
    @pulumi.getter(name="receiversId")
    def receivers_id(self) -> builtins.str:
        """
        The first ID of the resource.
        """
        return pulumi.get(self, "receivers_id")

    @property
    @pulumi.getter(name="receiversName")
    def receivers_name(self) -> builtins.str:
        """
        The name of the resource.
        """
        return pulumi.get(self, "receivers_name")

    @property
    @pulumi.getter
    def status(self) -> builtins.int:
        """
        The status of the resource.
        """
        return pulumi.get(self, "status")


@pulumi.output_type
class GetTagsTagResult(dict):
    def __init__(__self__, *,
                 id: builtins.str,
                 tag_id: builtins.str,
                 tag_name: builtins.str):
        """
        :param builtins.str id: The ID of the tag.
        :param builtins.str tag_id: The ID of the tag.
        :param builtins.str tag_name: The name of the tag.
        """
        pulumi.set(__self__, "id", id)
        pulumi.set(__self__, "tag_id", tag_id)
        pulumi.set(__self__, "tag_name", tag_name)

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The ID of the tag.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="tagId")
    def tag_id(self) -> builtins.str:
        """
        The ID of the tag.
        """
        return pulumi.get(self, "tag_id")

    @property
    @pulumi.getter(name="tagName")
    def tag_name(self) -> builtins.str:
        """
        The name of the tag.
        """
        return pulumi.get(self, "tag_name")


