# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = [
    'InstanceEnvironmentVar',
    'GetInstancesInstanceResult',
]

@pulumi.output_type
class InstanceEnvironmentVar(dict):
    def __init__(__self__, *,
                 key: Optional[builtins.str] = None,
                 value: Optional[builtins.str] = None):
        """
        :param builtins.str key: Keys for environment variables
        :param builtins.str value: Values of environment variables
        """
        if key is not None:
            pulumi.set(__self__, "key", key)
        if value is not None:
            pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter
    def key(self) -> Optional[builtins.str]:
        """
        Keys for environment variables
        """
        return pulumi.get(self, "key")

    @property
    @pulumi.getter
    def value(self) -> Optional[builtins.str]:
        """
        Values of environment variables
        """
        return pulumi.get(self, "value")


@pulumi.output_type
class GetInstancesInstanceResult(dict):
    def __init__(__self__, *,
                 client_instance_id: builtins.str,
                 client_instance_name: builtins.str,
                 client_instance_type: builtins.str,
                 id: builtins.str,
                 instance_id: builtins.str,
                 instance_name: builtins.str,
                 instance_type: builtins.str,
                 status: builtins.str,
                 zone_id: builtins.str):
        """
        :param builtins.str client_instance_id: The ID of the ECS instance to be bound.
        :param builtins.str client_instance_name: The name of the ECS instance bound to the EAIS instance.
        :param builtins.str client_instance_type: The type of the ECS instance bound to the EAIS instance.
        :param builtins.str id: The ID of the Instance.
        :param builtins.str instance_id: The ID of the resource.
        :param builtins.str instance_name: The name of the resource.
        :param builtins.str instance_type: The type of the resource. Valid values: `eais.ei-a6.4xlarge`, `eais.ei-a6.2xlarge`, `eais.ei-a6.xlarge`, `eais.ei-a6.large`, `eais.ei-a6.medium`.
        :param builtins.str status: The status of the resource. Valid values: `Attaching`, `Available`, `Detaching`, `InUse`, `Starting`, `Unavailable`.
        :param builtins.str zone_id: The ID of the region to which the EAIS instance belongs.
        """
        pulumi.set(__self__, "client_instance_id", client_instance_id)
        pulumi.set(__self__, "client_instance_name", client_instance_name)
        pulumi.set(__self__, "client_instance_type", client_instance_type)
        pulumi.set(__self__, "id", id)
        pulumi.set(__self__, "instance_id", instance_id)
        pulumi.set(__self__, "instance_name", instance_name)
        pulumi.set(__self__, "instance_type", instance_type)
        pulumi.set(__self__, "status", status)
        pulumi.set(__self__, "zone_id", zone_id)

    @property
    @pulumi.getter(name="clientInstanceId")
    def client_instance_id(self) -> builtins.str:
        """
        The ID of the ECS instance to be bound.
        """
        return pulumi.get(self, "client_instance_id")

    @property
    @pulumi.getter(name="clientInstanceName")
    def client_instance_name(self) -> builtins.str:
        """
        The name of the ECS instance bound to the EAIS instance.
        """
        return pulumi.get(self, "client_instance_name")

    @property
    @pulumi.getter(name="clientInstanceType")
    def client_instance_type(self) -> builtins.str:
        """
        The type of the ECS instance bound to the EAIS instance.
        """
        return pulumi.get(self, "client_instance_type")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The ID of the Instance.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> builtins.str:
        """
        The ID of the resource.
        """
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter(name="instanceName")
    def instance_name(self) -> builtins.str:
        """
        The name of the resource.
        """
        return pulumi.get(self, "instance_name")

    @property
    @pulumi.getter(name="instanceType")
    def instance_type(self) -> builtins.str:
        """
        The type of the resource. Valid values: `eais.ei-a6.4xlarge`, `eais.ei-a6.2xlarge`, `eais.ei-a6.xlarge`, `eais.ei-a6.large`, `eais.ei-a6.medium`.
        """
        return pulumi.get(self, "instance_type")

    @property
    @pulumi.getter
    def status(self) -> builtins.str:
        """
        The status of the resource. Valid values: `Attaching`, `Available`, `Detaching`, `InUse`, `Starting`, `Unavailable`.
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter(name="zoneId")
    def zone_id(self) -> builtins.str:
        """
        The ID of the region to which the EAIS instance belongs.
        """
        return pulumi.get(self, "zone_id")


